//package cn.com.connor.bh.bhdemo.demos.web.config;
//
//import com.fasterxml.jackson.databind.ObjectMapper;
//import org.apache.commons.io.IOUtils;
//import org.springframework.http.HttpInputMessage;
//import org.springframework.http.converter.HttpMessageNotReadableException;
//import org.springframework.http.converter.json.MappingJackson2HttpMessageConverter;
//
//import java.io.IOException;
//import java.nio.charset.StandardCharsets;
//
//public class Utf8SafeMappingJackson2HttpMessageConverter extends MappingJackson2HttpMessageConverter {
//    private final ObjectMapper objectMapper;
//
//    public Utf8SafeMappingJackson2HttpMessageConverter(ObjectMapper objectMapper) {
//        this.objectMapper = objectMapper;
//    }
//
//    @Override
//    protected Object readInternal(Class<?> clazz, HttpInputMessage inputMessage) throws IOException, HttpMessageNotReadableException {
//        byte[] body = IOUtils.toByteArray(inputMessage.getBody());
//        try {
//            // 检查是否为有效UTF-8
//            String content = new String(body, StandardCharsets.UTF_8);
//            validateUtf8(content);
//            return objectMapper.readValue(content, clazz);
//        } catch (IllegalArgumentException e) {
//            throw new HttpMessageNotReadableException("Invalid UTF-8 encoding in request body", e, inputMessage);
//        }
//    }
//
//    private void validateUtf8(String content) {
//        if (!StandardCharsets.UTF_8.newEncoder().canEncode(content)) {
//            throw new IllegalArgumentException("Invalid UTF-8 characters found");
//        }
//    }
//}
