package cn.com.connor.bh.bhdemo.demos.web.controller;

import cn.com.connor.bh.bhdemo.demos.web.Constants.Constants;
import cn.com.connor.bh.bhdemo.demos.web.mapper.TaskMapper;
import cn.com.connor.bh.bhdemo.demos.web.service.CallExeService;
import cn.com.connor.bh.bhdemo.demos.web.service.MqQueueService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@RestController
@RequestMapping("/drawing")
public class DrawingController {
    @Autowired
    private CallExeService callExeService;
    @Autowired
    private TaskMapper taskMapper;
    @Autowired
    private MqQueueService mqQueueService;

    @PostMapping("/getByMSG")
    public int getByMSG(@RequestBody Map<String, Object> map) {
        System.out.println("getByMSG - 已收到异步任务信息："+ map.toString());
        int result = 0;
        try {
            String param = map.get("MSG").toString();
            System.out.println("----"+param);
            result = taskMapper.getByMSG(param);
            System.out.println("==>result:"+result);
        }catch (Exception e){
            e.printStackTrace();
            System.out.println("》》》》》》》》》》转发异常《《《《《《《《《《");
            return 0;
        }
        System.out.println("getByMSG方法执行完毕！");
        return result;
    }

    @PostMapping("/updateTask")
    public int updateTask(@RequestBody Map<String, Object> map) {
        System.out.println("updateTask - 已收到异步任务信息："+ map.toString());
        int result = 0;
        try {
            String param = map.get("MSG").toString();
            System.out.println("----"+param);
            result = taskMapper.updateTask(map);
            System.out.println("==>result:"+result);
//            callExeService.callExe();
            mqQueueService.sendMsgToQueue(param);
        }catch (Exception e){
            e.printStackTrace();
            System.out.println("》》》》》》》》》》转发异常《《《《《《《《《《");
            return 0;
        }
        System.out.println("updateTask方法执行完毕！");
        return result;
    }

    @PostMapping("/insertTask")
    public int insertTask(@RequestBody Map<String, Object> map) {
        System.out.println("insertTask - 已收到异步任务信息："+ map.toString());
        int result = 0;
        try {
            String param = map.get("MSG").toString();
            System.out.println("----"+param);
            result = taskMapper.insertTask(map);
            System.out.println("==>result:"+result);
//            callExeService.callExe();
            mqQueueService.sendMsgToQueue(param);
        }catch (Exception e){
            e.printStackTrace();
            System.out.println("》》》》》》》》》》转发异常《《《《《《《《《《");
            return Constants.FAIL;
        }
        System.out.println("insertTask方法执行完毕！");
        return result;
    }

    /**
     * 场景：handler下发时触发
     * 解释：因为handler操作数据库使用单独的c++库，而手动下发通过当前服务操作数据库后会直接触发，不用单独调用一次
     *
     */
    @GetMapping
    public void drawToExe() {
        System.out.println("已收到异步任务请求，开始调用exe程序");
        try {
//            callExeService.callExe();
            mqQueueService.sendMsgToQueue("handler");
        }catch (Exception e){
            e.printStackTrace();
            System.out.println("》》》》》》》》》》转发异常《《《《《《《《《《");
        }
        System.out.println("drawToExe方法执行完毕！");
    }
}
